%--------------------------------------------------------------------------
% Signals and Systems II - Exercise 3 (c)
%
% Visualization of the carrier signals for phase modulation (PM) and
% frequency modulation (FM).
%
%
% Nov. 2010
% Revised: Nov. 2011, Nov. 2014
% Digital Signal Processing and System Theory
% Faculty of Engineering Christian-Albrechts-Universitt zu Kiel
% Jochen Withopf, jow@tf.uni-kiel.de
%--------------------------------------------------------------------------

N     = 1000;
v_hat = 10;
c_hat = 1;
w_T   = 2;
k     = 1;

v = [zeros(N,1); linspace(0, v_hat, N)'; v_hat*ones(N,1)];
t = linspace(-6, 12, length(v))';
%v = 1*sin(2*t);
%v = [sin(1*t(1:N)); sin(2*t(N+1:2*N)); sin(3*t(2*N+1:3*N))];

c_pm = c_hat * cos(w_T*t + k*2*pi*v);
c_fm = c_hat * cos(w_T*t + k*2*pi*cumsum(v)/N);


%--------------------------------------------------------------------------
% Plots
%--------------------------------------------------------------------------
lw = 1;
sp(1) = subplot(511);
plot(t,v, 'LineWidth', lw);
ylabel('Modulation signal');
set(gca, 'XTick', [0 6]);
set(gca, 'XTickLabel', {'0', 't1'});
ylim([1.1*min(v)-0.1*max(v) 1.1*max(v)]);
line([0 0], get(gca, 'YLim'), 'Color', 0.3*[1 1 1]);
line([6 6], get(gca, 'YLim'), 'Color', 0.3*[1 1 1]);

sp(2) = subplot(5,1,2:3);
plot(t,c_pm, 'LineWidth', lw)
ylabel('Phase modulation');
set(gca, 'XTick', [0 6]);
set(gca, 'XTickLabel', {'0', 't1'});
set(gca, 'YTick', [-c_hat 0 c_hat]);
ylim(1.1 * get(gca, 'YLim'));
line([0 0], get(gca, 'YLim'), 'Color', 0.3*[1 1 1]);
line([6 6], get(gca, 'YLim'), 'Color', 0.3*[1 1 1]);

sp(3) = subplot(5,1,4:5);
plot(t,c_fm, 'LineWidth', lw)
ylabel('Frequency modulation');
xlabel('Time');
set(gca, 'XTick', [0 6]);
set(gca, 'XTickLabel', {'0', 't1'});
set(gca, 'YTick', [-c_hat 0 c_hat]);
ylim(1.1 * get(gca, 'YLim'));
line([0 0], get(gca, 'YLim'), 'Color', 0.3*[1 1 1]);
line([6 6], get(gca, 'YLim'), 'Color', 0.3*[1 1 1]);

linkaxes(sp, 'x')
