%--------------------------------------------------------------------------
% Signals and Systems II - "Demo" for Problem 7
%
% Analysis of a random process: calculate mean and variance (with both own
% implementations and the MATLAB built-in functions), plot the process and
% its histogram.
%
%
% Nov. 2010
% Revised: Nov. 2011
% Digital Signal Processing and System Theory
% Faculty of Engineering Christian-Albrechts-Universitt zu Kiel
% Jochen Withopf, jow@tf.uni-kiel.de
%--------------------------------------------------------------------------

N = 1000;                    % Anzahl der Datenpunkte (Samples)
v = rand(N, 1);              % Zufallsgenerator fr Gleichverteilung
%v = randn(N, 1);            % Zufallsgenerator fr Normalverteilung (Gauverteilung)
v = ss2_ue_a7_myrand(N, 1); % Zufallsgenerator fr Normalverteilung mit zuflligem Mittelwert je Realisierung

m        = 0;
sigma_sq = 0;

% --- Mittelwertschtzung (entspricht dem MATLAB-Befehl mean(v) )
for i=1:N                    % Summe des Schtzers berechenen (ginge z.B.
    m = m + v(i);            % auch mit dem Befehl m = sum(v) )
end

m = m/N;                     % Normalisierung auf Anzahl der Datenpunkte


% --- Varianzschtzung (entspricht dem MATLAB-Befehl var(v) )
for i=1:N
    sigma_sq = sigma_sq + (v(i) - m)^2;  
end

sigma_sq = sigma_sq / (N);       % Normalisierung auf Anzahl der Datenpunkte
%sigma_sq = sigma_sq / (N - 1);  % Normalisierung des MATLAB-Schtzers

% --- Vergleich zwischen unseren Implementierungen und dem MATLAB-Schtzer
%[m sigma_sq; mean(v) var(v)]   % Zum Vergleich die Schtungen in eine Matrix eintragen und ausgeben (da kein ; )

% --- Plots erstellen
figure;                       % Neues Fenster fr Plots ffnen
subplot(2,1,1);               % Oberes Subplotfenster anlegen
plot(v);                      % Daten darstellen
title(['Zufallsprozess: m = ' num2str(m) ', \sigma^2 = ' num2str(sigma_sq)]);
xlabel('Sampleindex');
ylabel('Amplitude');
grid on;

subplot(2,1,2);               % Unteres Subplotfenster anlegen
numBins = 30;                 % Anzahl der Intervalle des Histograms festlegen
hist(v, numBins);             % Histogramm berechenen und darstellen
set(gca, 'XLim', [min(v)-0.5 max(v)+0.5]);    % Wertebereich der x-Achse vergrern
xlabel('Amplitudenwert');
ylabel('Absolute Hufigkeit');
grid on;



