
%--------------------------------------------------------------------------
% Set parameters and initialize variables
%--------------------------------------------------------------------------
N = 1024;
w = linspace(0, 1, N);
a = [0.2 0.3 0.4];
H = zeros(length(a), N);
 
leg = [];
 
%--------------------------------------------------------------------------
% Calculate transfer function
%--------------------------------------------------------------------------
for i=1:length(a)
    H(i,:) = abs(a(i)./(a(i) + 1j*w)).^2;
    leg = strvcat(leg, ['$\alpha = ' num2str(a(i)) '$']);
end
 
%--------------------------------------------------------------------------
% Linear plot
%--------------------------------------------------------------------------
set(0,'defaulttextinterpreter','none')
set(gcf, 'Position', [1400 730 950 420]);

subplot(121)
plot(w, H, 'LineWidth', 1);
xlabel('Kreisfrequenz $\omega$');
ylabel('$|H(j\omega)|^2$');
legend(leg, 'Location', 'NorthEast');
grid on
 
%--------------------------------------------------------------------------
% dB plot
%--------------------------------------------------------------------------
subplot(122)
plot(w, 10*log10(H), 'LineWidth', 1);
xlabel('Kreisfrequenz $\omega$');
ylabel('$20\log_{10}|H(j\omega)|$');
%legend(leg, 'Location', 'Best');
grid on

%--------------------------------------------------------------------------
% Save
%--------------------------------------------------------------------------
legend2latex(gcf);
laprint(gcf, '../img/ss2_ue_stoch_sig_sys_1_transfer_function_new');

set(0,'defaulttextinterpreter','tex')